##初步

    git init
    git remote add origin http://url.git
    git commit -m "import"
    git push origin master

###签出代码库

    git clone http://url.git dirName
    git checkout origin
    git commit -m "modify"
    git push

##分支
###创建分支

    git branch branchName
    git branch -m <old_name> <new_name> 改名字 (如果有同名會失敗，改用 -M 可以強制覆蓋)

###切换分支

    git checkout branchName
    
> 注意:如果你有檔案修改了卻還沒 commit，會不能切換 branch

    git checkout -b <new_branch_name> (<from_branch_name>) 本地建立 branch 並立即 checkout 切換過去

    
###删除分支

删除远程分支

    git push origin --delete <branchName>
    
    git branch -d -r branchname 删除远程branchname分支

    git push origin :branch-name 推送一个空分支到远程分支，其实就相当于删除远程分支

##Tag

显示本地Tag

git tag
 
- 0.6.7
- 0.6.8
- 0.8.0

###添加tag

    git tag 0.8.0
    git tag -a 0.8.0 -m "comment"
    
###推送Tag到远程

    git push --tag

###删除本地tag
    git tag -d 0.8.0
    
    Deleted tag '0.8.0' (was 126095d)

###删除远程tag
    git push origin --delete tag <tagname>
    
    git push origin :refs/tags/0.8.0  推送一个空tag到远程tag
    
    remote: Updating references: 100% (1/1)
    To http://zhenqin-pro102/git/katta.git
    - [deleted]         0.8.0