##Maven重要操作

---

[Maven的POM模板](maven%2Fpom.xml)

创建Maven项目

    mvn archetype:create -DgroupId=net.mvntest -DartifactId=mvntest -DpackageName=net.mvntest -Dversion=1.0 -Dpackaging=war

给Maven仓库安装一个本地Jar库

    mvn install:install-file -Dfile={workspace}/lib/ndetl-client-1.0.jar -DgroupId=com.sdyc -DartifactId=ndetl-client -Dversion=1.0 -Dpackaging=jar -DgeneratePom=true

生成Eclipse项目骨架

    mvn eclipse:eclipse

生成Eclipse项目骨架

    mvn idea:module

编译代码
    
    mvn compile
    mvn compiler:compile

Copy Resources

    mvn resources:resources

打包代码

    mvn jar:jar
    mvn package
    mvn war:war

运行Java程序

    mvn exec:java
    
运行Web程序

    mvn jetty:run
    mvn tomcat:run

把项目安装到本地

    mvn install

使Maven下载jar的sources，方便在IDE中查看代码

    mvn dependency:sources

使Maven下载jar的Javadoc

    mvn dependency:resolve -Dclassifier=javadoc 

把依赖的jar copy到项目的target/dependency目录下

    mvn dependency:copy-dependencies
    

